<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>magpar: init/parinit.c Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<!-- Generated by Doxygen 1.6.3 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Data&nbsp;Structures</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.html"><span>File&nbsp;List</span></a></li>
      <li><a href="globals.html"><span>Globals</span></a></li>
    </ul>
  </div>
  <div class="navpath"><a class="el" href="dir_f813120d4be15aaed9e35a3518d2a85e.html">init</a>
  </div>
</div>
<div class="contents">
<h1>parinit.c</h1><a href="parinit_8c.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">    This file is part of magpar.</span>
<a name="l00003"></a>00003 <span class="comment"></span>
<a name="l00004"></a>00004 <span class="comment">    Copyright (C) 2002-2010 Werner Scholz</span>
<a name="l00005"></a>00005 <span class="comment"></span>
<a name="l00006"></a>00006 <span class="comment">    www:   http://www.magpar.net/</span>
<a name="l00007"></a>00007 <span class="comment">    email: magpar(at)magpar.net</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">    magpar is free software; you can redistribute it and/or modify</span>
<a name="l00010"></a>00010 <span class="comment">    it under the terms of the GNU General Public License as published by</span>
<a name="l00011"></a>00011 <span class="comment">    the Free Software Foundation; either version 2 of the License, or</span>
<a name="l00012"></a>00012 <span class="comment">    (at your option) any later version.</span>
<a name="l00013"></a>00013 <span class="comment"></span>
<a name="l00014"></a>00014 <span class="comment">    magpar is distributed in the hope that it will be useful,</span>
<a name="l00015"></a>00015 <span class="comment">    but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00016"></a>00016 <span class="comment">    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the</span>
<a name="l00017"></a>00017 <span class="comment">    GNU General Public License for more details.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">    You should have received a copy of the GNU General Public License</span>
<a name="l00020"></a>00020 <span class="comment">    along with magpar; if not, write to the Free Software</span>
<a name="l00021"></a>00021 <span class="comment">    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00022"></a>00022 <span class="comment">*/</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Id[] = <span class="stringliteral">&quot;$Id: parinit.c 2962 2010-02-04 19:50:44Z scholz $\n\n&quot;</span>;
<a name="l00025"></a>00025 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Td[] = <span class="stringliteral">&quot;$Today: &quot;</span> __FILE__ <span class="stringliteral">&quot;  &quot;</span> __DATE__ <span class="stringliteral">&quot;  &quot;</span>  __TIME__  <span class="stringliteral">&quot; $\n\n&quot;</span>;
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="init_8h.html">init.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="magpario_8h.html">io/magpario.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="field_8h.html">field/field.h</a>&quot;</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="preprocessor">#ifdef SUNDIALS_VERSION</span>
<a name="l00032"></a>00032 <span class="preprocessor"></span><span class="preprocessor">#include &quot;<a class="code" href="llg_8h.html">llg/llg.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#endif</span>
<a name="l00034"></a>00034 <span class="preprocessor"></span>
<a name="l00035"></a>00035 <span class="preprocessor">#ifdef TAO</span>
<a name="l00036"></a>00036 <span class="preprocessor"></span><span class="preprocessor">#include &quot;<a class="code" href="emini_8h.html">emini/emini.h</a>&quot;</span>
<a name="l00037"></a>00037 <span class="preprocessor">#endif</span>
<a name="l00038"></a>00038 <span class="preprocessor"></span>
<a name="l00039"></a>00039 <span class="preprocessor">#ifdef PNG</span>
<a name="l00040"></a>00040 <span class="preprocessor"></span><span class="preprocessor">#include &quot;<a class="code" href="writepng_8h.html">png/writepng.h</a>&quot;</span>
<a name="l00041"></a>00041 <span class="preprocessor">#endif</span>
<a name="l00042"></a>00042 <span class="preprocessor"></span>
<a name="l00043"></a>00043 <span class="preprocessor">#ifdef ADDONS</span>
<a name="l00044"></a>00044 <span class="preprocessor"></span><span class="preprocessor">#include &quot;addons/addons.h&quot;</span>
<a name="l00045"></a>00045 <span class="preprocessor">#include &quot;llgts/llgts.h&quot;</span>
<a name="l00046"></a>00046 <span class="preprocessor">#include &quot;llg2/llg2.h&quot;</span>
<a name="l00047"></a>00047 <span class="preprocessor">#include &quot;brown/brown.h&quot;</span>
<a name="l00048"></a>00048 <span class="preprocessor">#endif</span>
<a name="l00049"></a>00049 <span class="preprocessor"></span>
<a name="l00050"></a>00050 <span class="preprocessor">#ifdef EBM</span>
<a name="l00051"></a>00051 <span class="preprocessor"></span><span class="preprocessor">#include &quot;ebm/ebm.h&quot;</span>
<a name="l00052"></a>00052 <span class="preprocessor">#endif</span>
<a name="l00053"></a>00053 <span class="preprocessor"></span>
<a name="l00054"></a><a class="code" href="parinit_8c.html#aab78598aa0d3ece1097d988997f0aea3">00054</a> <span class="keywordtype">int</span> <a class="code" href="init_8h.html#aab78598aa0d3ece1097d988997f0aea3">ParInit</a>(<a class="code" href="structGridData.html">GridData</a> *gdata)
<a name="l00055"></a>00055 {
<a name="l00056"></a>00056   PetscTruth   flg;
<a name="l00057"></a>00057 
<a name="l00058"></a>00058   <a class="code" href="griddata_8h.html#a3d9da926137619fd02adb245a08536c7">MagparFunctionLogBegin</a>;
<a name="l00059"></a>00059 
<a name="l00060"></a>00060   PetscPrintf(MPI_COMM_WORLD,
<a name="l00061"></a>00061     <span class="stringliteral">&quot;--------------------------------------------------------------------------\n&quot;</span>
<a name="l00062"></a>00062     <span class="stringliteral">&quot;Starting parallel part\n\n&quot;</span>
<a name="l00063"></a>00063   );
<a name="l00064"></a>00064 
<a name="l00065"></a>00065   <span class="comment">/* initialize mode here: Hdemag needs it */</span>
<a name="l00066"></a>00066   ierr = PetscOptionsGetInt(PETSC_NULL,<span class="stringliteral">&quot;-mode&quot;</span>,(<a class="code" href="griddata_8h.html#a515706180f960b30595b607f2d734d14" title="Contains all data to control the simulations.">PetscInt</a>*)&amp;gdata-&gt;<a class="code" href="structGridData.html#ae420f7fb3d60720f21c5852955b94eae">mode</a>,&amp;flg);CHKERRQ(ierr);
<a name="l00067"></a>00067   <span class="keywordflow">if</span> (flg!=PETSC_TRUE) {
<a name="l00068"></a>00068     gdata-&gt;<a class="code" href="structGridData.html#ae420f7fb3d60720f21c5852955b94eae">mode</a>=99;
<a name="l00069"></a>00069     PetscPrintf(PETSC_COMM_WORLD,
<a name="l00070"></a>00070       <span class="stringliteral">&quot;Option -mode not found, using default value: %i\n&quot;</span>,
<a name="l00071"></a>00071       gdata-&gt;<a class="code" href="structGridData.html#ae420f7fb3d60720f21c5852955b94eae">mode</a>
<a name="l00072"></a>00072     );
<a name="l00073"></a>00073   }
<a name="l00074"></a>00074   PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;run mode: %i\n&quot;</span>,gdata-&gt;<a class="code" href="structGridData.html#ae420f7fb3d60720f21c5852955b94eae">mode</a>);
<a name="l00075"></a>00075 
<a name="l00076"></a>00076   <span class="comment">/* modify material properties */</span>
<a name="l00077"></a>00077   ierr = <a class="code" href="init_8h.html#a5b18b26ca79926b582bf94e21e5f531b">ModifyPropPar</a>(gdata);CHKERRQ(ierr);
<a name="l00078"></a>00078 
<a name="l00079"></a>00079   ierr = <a class="code" href="elevertvol_8c.html#a2103238be825fa27dce52bbc795d532d">EleVertVol</a>(gdata);CHKERRQ(ierr);
<a name="l00080"></a>00080 
<a name="l00081"></a>00081   gdata-&gt;<a class="code" href="structGridData.html#aa694f80ac28e20e0d11e13a3db947ed4">equil</a>=0;
<a name="l00082"></a>00082   <span class="comment">/* Initialize with large value to avoid artificial equilibrium at start of simulation.</span>
<a name="l00083"></a>00083 <span class="comment">     Also done in first call to EquilCheck().</span>
<a name="l00084"></a>00084 <span class="comment">  */</span>
<a name="l00085"></a>00085   gdata-&gt;<a class="code" href="structGridData.html#ad44d2e83b58c9fc6b13f7fb3258bc323">vequil</a>=1.0;
<a name="l00086"></a>00086 
<a name="l00087"></a>00087   PetscReal  tstart;
<a name="l00088"></a>00088   ierr = PetscOptionsGetReal(PETSC_NULL,<span class="stringliteral">&quot;-ts_init_time&quot;</span>,&amp;tstart,&amp;flg);CHKERRQ(ierr);
<a name="l00089"></a>00089   <span class="keywordflow">if</span> (flg!=PETSC_TRUE) {
<a name="l00090"></a>00090     tstart=0;
<a name="l00091"></a>00091     PetscPrintf(PETSC_COMM_WORLD,
<a name="l00092"></a>00092       <span class="stringliteral">&quot;Option -ts_init_time not found, using default value: %g\n&quot;</span>,
<a name="l00093"></a>00093       tstart
<a name="l00094"></a>00094     );
<a name="l00095"></a>00095   }
<a name="l00096"></a>00096   PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;initial time: %g\n&quot;</span>,tstart);
<a name="l00097"></a>00097   tstart /= 1e9*gdata-&gt;<a class="code" href="structGridData.html#ad7a22de0cb266e66e8dbcb1bb147bae8">tscale</a>;
<a name="l00098"></a>00098   PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;reduced initial time:      %g (1)\n&quot;</span>,tstart);
<a name="l00099"></a>00099   gdata-&gt;<a class="code" href="structGridData.html#a9eb9246406e97a2a4a8a9c471b11aa2a">time</a>=tstart;
<a name="l00100"></a>00100 
<a name="l00101"></a>00101   ierr = <a class="code" href="field_8h.html#ab9d30ce64708afeca163280386deb654">Htot</a>(gdata);CHKERRQ(ierr);
<a name="l00102"></a>00102   ierr = <a class="code" href="field_8h.html#a09d3a5bbcb3e65c1e4c7e22818377b13">Htot_Energy</a>(gdata);CHKERRQ(ierr);
<a name="l00103"></a>00103 
<a name="l00104"></a>00104   <span class="keywordflow">switch</span> (gdata-&gt;<a class="code" href="structGridData.html#ae420f7fb3d60720f21c5852955b94eae">mode</a>) {
<a name="l00105"></a>00105     <span class="keywordflow">case</span> 0:
<a name="l00106"></a>00106       <span class="comment">/* LLG time integration */</span>
<a name="l00107"></a>00107 <span class="preprocessor">#ifdef SUNDIALS_VERSION</span>
<a name="l00108"></a>00108 <span class="preprocessor"></span>      ierr = <a class="code" href="mytscreatepvode_8c.html#a9671ea286af405e584ae7468a0ce15b3">myTSCreatePVode</a>(gdata);CHKERRQ(ierr);
<a name="l00109"></a>00109       ierr = <a class="code" href="magpario_8h.html#afcfe52b023f7bd7762b109bea3096cfc">WriteFEMAVS</a>(gdata);CHKERRQ(ierr);
<a name="l00110"></a>00110       ierr = <a class="code" href="checkiterationllg_8c.html#a5433821a82b3ad3af34bb43677541a33">CheckIterationLLG</a>(gdata);CHKERRQ(ierr);
<a name="l00111"></a>00111 <span class="preprocessor">#else</span>
<a name="l00112"></a>00112 <span class="preprocessor"></span>      SETERRQ(PETSC_ERR_ARG_OUTOFRANGE,<span class="stringliteral">&quot;PVODE not compiled in! Exiting!\n&quot;</span>);
<a name="l00113"></a>00113 <span class="preprocessor">#endif</span>
<a name="l00114"></a>00114 <span class="preprocessor"></span>    <span class="keywordflow">break</span>;
<a name="l00115"></a>00115     <span class="keywordflow">case</span> 1:
<a name="l00116"></a>00116       <span class="comment">/* energy minimization */</span>
<a name="l00117"></a>00117 <span class="preprocessor">#ifdef TAO</span>
<a name="l00118"></a>00118 <span class="preprocessor"></span>      ierr = <a class="code" href="eminisolve_8c.html#a7be0557728f95ef22f1ba7f2b99b5707">myTSCreateEmini</a>(gdata);CHKERRQ(ierr);
<a name="l00119"></a>00119       ierr = <a class="code" href="magpario_8h.html#afcfe52b023f7bd7762b109bea3096cfc">WriteFEMAVS</a>(gdata);CHKERRQ(ierr);
<a name="l00120"></a>00120       ierr = <a class="code" href="checkiterationemini_8c.html#a1c9f3282235f811af60323611535e99b">CheckIterationEmini</a>(gdata);CHKERRQ(ierr);
<a name="l00121"></a>00121 <span class="preprocessor">#else</span>
<a name="l00122"></a>00122 <span class="preprocessor"></span>      SETERRQ(PETSC_ERR_ARG_OUTOFRANGE,<span class="stringliteral">&quot;TAO not compiled in! Exiting!\n&quot;</span>);
<a name="l00123"></a>00123 <span class="preprocessor">#endif</span>
<a name="l00124"></a>00124 <span class="preprocessor"></span>    <span class="keywordflow">break</span>;
<a name="l00125"></a>00125     <span class="keywordflow">case</span> 2:
<a name="l00126"></a>00126       <span class="comment">/* relax with high damping and no precession during t&lt;0,</span>
<a name="l00127"></a>00127 <span class="comment">         then switch to normal damping</span>
<a name="l00128"></a>00128 <span class="comment">      */</span>
<a name="l00129"></a>00129 <span class="preprocessor">#ifdef SUNDIALS_VERSION</span>
<a name="l00130"></a>00130 <span class="preprocessor"></span>      ierr = <a class="code" href="mytscreatepvode_8c.html#a9671ea286af405e584ae7468a0ce15b3">myTSCreatePVode</a>(gdata);CHKERRQ(ierr);
<a name="l00131"></a>00131       ierr = <a class="code" href="magpario_8h.html#afcfe52b023f7bd7762b109bea3096cfc">WriteFEMAVS</a>(gdata);CHKERRQ(ierr);
<a name="l00132"></a>00132       ierr = <a class="code" href="checkiterationllg_8c.html#a5433821a82b3ad3af34bb43677541a33">CheckIterationLLG</a>(gdata);CHKERRQ(ierr);
<a name="l00133"></a>00133 <span class="preprocessor">#else</span>
<a name="l00134"></a>00134 <span class="preprocessor"></span>      SETERRQ(PETSC_ERR_ARG_OUTOFRANGE,<span class="stringliteral">&quot;PVODE not compiled in! Exiting!\n&quot;</span>);
<a name="l00135"></a>00135 <span class="preprocessor">#endif</span>
<a name="l00136"></a>00136 <span class="preprocessor"></span>    <span class="keywordflow">break</span>;
<a name="l00137"></a>00137       <span class="comment">/* relax with energy minimization, then switch to LLG time integration */</span>
<a name="l00138"></a>00138     <span class="keywordflow">case</span> 3:
<a name="l00139"></a>00139 <span class="preprocessor">#ifdef TAO</span>
<a name="l00140"></a>00140 <span class="preprocessor"></span>      ierr = <a class="code" href="eminisolve_8c.html#a7be0557728f95ef22f1ba7f2b99b5707">myTSCreateEmini</a>(gdata);CHKERRQ(ierr);
<a name="l00141"></a>00141       ierr = <a class="code" href="magpario_8h.html#afcfe52b023f7bd7762b109bea3096cfc">WriteFEMAVS</a>(gdata);CHKERRQ(ierr);
<a name="l00142"></a>00142       ierr = <a class="code" href="checkiterationemini_8c.html#a1c9f3282235f811af60323611535e99b">CheckIterationEmini</a>(gdata);CHKERRQ(ierr);
<a name="l00143"></a>00143       PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;&gt;&gt; EminiSolve: Relaxing magnetization using energy minimization\n&quot;</span>);
<a name="l00144"></a>00144       ierr = <a class="code" href="eminisolve_8c.html#a17d21e725c11c8a2fade9a2d83d98047">EminiSolve</a>(gdata);CHKERRQ(ierr);
<a name="l00145"></a>00145       gdata-&gt;<a class="code" href="structGridData.html#a4cc9b420611ac5eed22ee3bb2533fde4">inp</a>=PetscAbsInt(gdata-&gt;<a class="code" href="structGridData.html#a4cc9b420611ac5eed22ee3bb2533fde4">inp</a>);
<a name="l00146"></a>00146 
<a name="l00147"></a>00147 <span class="preprocessor">#ifdef SUNDIALS_VERSION</span>
<a name="l00148"></a>00148 <span class="preprocessor"></span>      ierr = <a class="code" href="mytscreatepvode_8c.html#a9671ea286af405e584ae7468a0ce15b3">myTSCreatePVode</a>(gdata);CHKERRQ(ierr);
<a name="l00149"></a>00149       ierr = <a class="code" href="checkiterationllg_8c.html#a5433821a82b3ad3af34bb43677541a33">CheckIterationLLG</a>(gdata);CHKERRQ(ierr);
<a name="l00150"></a>00150 <span class="preprocessor">#else</span>
<a name="l00151"></a>00151 <span class="preprocessor"></span>      SETERRQ(PETSC_ERR_ARG_OUTOFRANGE,<span class="stringliteral">&quot;PVODE not compiled in! Exiting!\n&quot;</span>);
<a name="l00152"></a>00152 <span class="preprocessor">#endif</span>
<a name="l00153"></a>00153 <span class="preprocessor"></span>
<a name="l00154"></a>00154 <span class="preprocessor">#else</span>
<a name="l00155"></a>00155 <span class="preprocessor"></span>      SETERRQ(PETSC_ERR_ARG_OUTOFRANGE,<span class="stringliteral">&quot;TAO not compiled in! Exiting!\n&quot;</span>);
<a name="l00156"></a>00156 <span class="preprocessor">#endif</span>
<a name="l00157"></a>00157 <span class="preprocessor"></span>    <span class="keywordflow">break</span>;
<a name="l00158"></a>00158 <span class="preprocessor">#ifdef ADDONS</span>
<a name="l00159"></a>00159 <span class="preprocessor"></span>    <span class="keywordflow">case</span> 4:
<a name="l00160"></a>00160       ierr = <a class="code" href="magpario_8h.html#afcfe52b023f7bd7762b109bea3096cfc">WriteFEMAVS</a>(gdata);CHKERRQ(ierr);
<a name="l00161"></a>00161       ierr = CheckIterationLLG2(gdata);CHKERRQ(ierr);
<a name="l00162"></a>00162     <span class="keywordflow">break</span>;
<a name="l00163"></a>00163 <span class="preprocessor">#endif</span>
<a name="l00164"></a>00164 <span class="preprocessor"></span>    <span class="keywordflow">case</span> 50:
<a name="l00165"></a>00165 <span class="preprocessor">#ifdef EBM</span>
<a name="l00166"></a>00166 <span class="preprocessor"></span>      <span class="comment">/* nudged elastic band method */</span>
<a name="l00167"></a>00167       ierr = myTSCreateEBM(gdata);CHKERRQ(ierr);
<a name="l00168"></a>00168       ierr = <a class="code" href="magpario_8h.html#afcfe52b023f7bd7762b109bea3096cfc">WriteFEMAVS</a>(gdata);CHKERRQ(ierr);
<a name="l00169"></a>00169 <span class="preprocessor">#else</span>
<a name="l00170"></a>00170 <span class="preprocessor"></span>      SETERRQ(PETSC_ERR_ARG_OUTOFRANGE,<span class="stringliteral">&quot;EBM not compiled in! Exiting!\n&quot;</span>);
<a name="l00171"></a>00171 <span class="preprocessor">#endif</span>
<a name="l00172"></a>00172 <span class="preprocessor"></span>    <span class="keywordflow">break</span>;
<a name="l00173"></a>00173 <span class="preprocessor">#ifdef ADDONS</span>
<a name="l00174"></a>00174 <span class="preprocessor"></span>    <span class="keywordflow">case</span> 51:
<a name="l00175"></a>00175       <span class="comment">/* LLG time integration with PETSc internal ODE solvers */</span>
<a name="l00176"></a>00176       ierr = myTSCreate(gdata);CHKERRQ(ierr);
<a name="l00177"></a>00177       ierr = <a class="code" href="magpario_8h.html#afcfe52b023f7bd7762b109bea3096cfc">WriteFEMAVS</a>(gdata);CHKERRQ(ierr);
<a name="l00178"></a>00178       ierr = CheckIterationLLGTS(gdata);CHKERRQ(ierr);
<a name="l00179"></a>00179     <span class="keywordflow">break</span>;
<a name="l00180"></a>00180     <span class="keywordflow">case</span> 52:
<a name="l00181"></a>00181       ierr = BrownInit(gdata);CHKERRQ(ierr);
<a name="l00182"></a>00182     <span class="keywordflow">break</span>;
<a name="l00183"></a>00183     <span class="keywordflow">case</span> 53:
<a name="l00184"></a>00184       <span class="comment">/* energy minimization with non-linear magnet */</span>
<a name="l00185"></a>00185 <span class="preprocessor">#ifdef TAO</span>
<a name="l00186"></a>00186 <span class="preprocessor"></span>      <span class="comment">/* shorten magnetization vectors to avoid starting in saturation */</span>
<a name="l00187"></a>00187       ierr = VecScale(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,0.1);CHKERRQ(ierr);
<a name="l00188"></a>00188       <span class="comment">/* need to recalculate field, energy after scaling M */</span>
<a name="l00189"></a>00189       ierr = <a class="code" href="field_8h.html#ab9d30ce64708afeca163280386deb654">Htot</a>(gdata);CHKERRQ(ierr);
<a name="l00190"></a>00190       ierr = <a class="code" href="field_8h.html#a09d3a5bbcb3e65c1e4c7e22818377b13">Htot_Energy</a>(gdata);CHKERRQ(ierr);
<a name="l00191"></a>00191 
<a name="l00192"></a>00192       ierr = <a class="code" href="eminisolve_8c.html#a7be0557728f95ef22f1ba7f2b99b5707">myTSCreateEmini</a>(gdata);CHKERRQ(ierr);
<a name="l00193"></a>00193       ierr = <a class="code" href="magpario_8h.html#afcfe52b023f7bd7762b109bea3096cfc">WriteFEMAVS</a>(gdata);CHKERRQ(ierr);
<a name="l00194"></a>00194       ierr = <a class="code" href="checkiterationemini_8c.html#a1c9f3282235f811af60323611535e99b">CheckIterationEmini</a>(gdata);CHKERRQ(ierr);
<a name="l00195"></a>00195 <span class="preprocessor">#else</span>
<a name="l00196"></a>00196 <span class="preprocessor"></span>      SETERRQ(PETSC_ERR_ARG_OUTOFRANGE,<span class="stringliteral">&quot;TAO not compiled in! Exiting!\n&quot;</span>);
<a name="l00197"></a>00197 <span class="preprocessor">#endif</span>
<a name="l00198"></a>00198 <span class="preprocessor"></span>    <span class="keywordflow">break</span>;
<a name="l00199"></a>00199 <span class="preprocessor">#endif</span>
<a name="l00200"></a>00200 <span class="preprocessor"></span>    <span class="keywordflow">case</span> 99:
<a name="l00201"></a>00201       <span class="comment">/* just calculate fields, energies, etc. once and exit */</span>
<a name="l00202"></a>00202       ierr = <a class="code" href="magpario_8h.html#ad970cf1663bac1ede525a5caf43750fd">WriteLog</a>(gdata);CHKERRQ(ierr);
<a name="l00203"></a>00203       ierr = <a class="code" href="magpario_8h.html#afcfe52b023f7bd7762b109bea3096cfc">WriteFEMAVS</a>(gdata);CHKERRQ(ierr);
<a name="l00204"></a>00204       ierr = <a class="code" href="magpario_8h.html#a7ff05d6bfdfc02445d6245fec57f686e">WriteSet</a>(gdata);CHKERRQ(ierr);
<a name="l00205"></a>00205     <span class="keywordflow">break</span>;
<a name="l00206"></a>00206     <span class="keywordflow">default</span>:
<a name="l00207"></a>00207       SETERRQ(PETSC_ERR_ARG_OUTOFRANGE,<span class="stringliteral">&quot;-mode out of valid range! Exiting!\n&quot;</span>);
<a name="l00208"></a>00208   }
<a name="l00209"></a>00209 
<a name="l00210"></a>00210   <span class="comment">/* destroy various objects, which are not required any more */</span>
<a name="l00211"></a>00211   ierr = <a class="code" href="destroyinit_8c.html#a1b4144014467c57b1ce5f003775cd266">DataDestroyInit</a>(gdata);CHKERRQ(ierr);
<a name="l00212"></a>00212 
<a name="l00213"></a>00213   <a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">MagparFunctionLogReturn</a>(0);
<a name="l00214"></a>00214 }
</pre></div></div>
  <hr>
  <address>
    magpar - Parallel Finite Element Micromagnetics Package<br>
    Copyright (C) 2002-2010 Werner Scholz
  </address>
  </body>
</html>

